/* Tsinghuaeolus soccer client for Robocup2001
 *
 * Computer Science Department
 * State Key Lab of Intelligent Technology and Systems
 * Tsinghua University
 * 
 * Copyright (C) 2001 Tsinghuaeolus
 * Team Leader : Lishi
 * Team memebers : ChenJiang, YaoJinyi, CaiYunpeng
 *
 * We thank CMU for CMU98 was used for reference in our initial stage.
 *
 * You may copy and distribute this program freely as long as you retain this notice.
 * If you make any changes or have any comments we would appreciate a message to yjy01@mails.tsinghua.edu.cn.
 * For more information, please see http://www.lits.tsinghua.edu.cn/RoboCup
 */

#ifndef _audiosystem
#define _audiosystem
#include "bpn.h"
#include "types.h"
#include "Command.h"
#include "Strategy.h"
#include "RSAClass.h"

enum MsgDataType{
	Msg_INT,
	Msg_ShortFloat,
	Msg_LongFloat
};

enum Msg_Type{
	Msg_MyPlayerPos = 12,
	Msg_TheirPlayerPos = 23,
	Msg_BallPos = 7,
	Msg_BallVel = 51,
	Msg_Pass = 73,
	Msg_Ballcontroller = 74,
};

class MsgData{
public:
	MsgData(float data = 0, MsgDataType precision = Msg_ShortFloat){ this->data =data; this->precision = precision;}
	MsgData(int data){ this->data =(float)data; this->precision = Msg_INT;}
	MsgDataType precision;
	float data;
	void operator =(float d){ this->data = d;}
};

static char map_of_printablechar[] ="0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSUVWXYZ().+-*/?<>_";
class AuditoryProcess{
private:
	char auditorybuffer[MAXMESG];
	char saybuffer[MAXMESG];
	int  p_auditorybuffer;
	float msgData[CP_max_msgdata];
	int MsgDataNum;
	int MsgNo;

//ciphertext
	inline int  ciphertext(char m);
	inline char deciphertext(int e);
	inline char map_into_printablechar(int i);
	inline int demap(char m);
	Time LastSpeakingTime;
public:
	AuditoryProcess();
/*********	AddMsg	*****************************/
	
	void AddData(MsgData msgdata);
	void AddMsg(int msgNo, MsgData msgdata);
	void AddMsg(int msgNo, MsgData msgdata1, MsgData msgdata2);
	void AddMsg(int msgNo, MsgData msgdata1, MsgData msgdata2, MsgData msgdata3);
	void AddMsg(int msgNo, MsgData msgdata1, MsgData msgdata2, MsgData msgdata3, MsgData msgdata4);
	void AddMsg(int msgNo, MsgData msgdata1, MsgData msgdata2, MsgData msgdata3, MsgData msgdata4, MsgData msgdata5);
	void AddMsg(int msgNo, MsgData msgdata1, MsgData msgdata2, MsgData msgdata3, MsgData msgdata4, MsgData msgdata5, MsgData msgdata6);
	void AddHeader();
	void ResetBuffer();
/*******	ProcessMsg	************************/
	void ProcessMsg(char* auditorymsg);
	bool ProcessSetMsg(char **p_buffer);
/**********	SendMsg	****************************/
	void SendMsg();
/************	RSA	****************************/
	RSAEncrypt rsa;
	int encrypt(int data);
	int decrypt(int data);
	void encipher(char* buffer, int len);
	void decipher(char* buffer, int len);
/***********	Announce	**********************/
	void AnnounceSelfPos();
	void AnnounceMyPlayerPos(UNum NO);
	void AnnounceTheirPlayerPos(UNum NO);
	void AnnounceBallPos();
	void AnnounceBallVel();
	void AnnounceBallcontroller();
	void AnnouncePass();
/***********	Hear	**********************/
	void HeardMyPlayerPos(UNum No, Time time);
	void HeardTheirPlayerPos(UNum No, Time time);
	void HeardBallPos(Time time);
	void HeardBallVel(Time time);
	void HeardBallcontrollers(Time time);
	void HeardPass(Time time);
/***********	Strategy	****************/
	bool IsCaptain(UNum NO);
	bool CanSpeak();
	void Communication();
};

#endif