/* Tsinghuaeolus soccer client for Robocup2001
 *
 * Computer Science Department
 * State Key Lab of Intelligent Technology and Systems
 * Tsinghua University
 * 
 * Copyright (C) 2001 Tsinghuaeolus
 * Team Leader : Lishi
 * Team memebers : ChenJiang, YaoJinyi, CaiYunpeng
 *
 * We thank CMU for CMU98 was used for reference in our initial stage.
 *
 * You may copy and distribute this program freely as long as you retain this notice.
 * If you make any changes or have any comments we would appreciate a message to yjy01@mails.tsinghua.edu.cn.
 * For more information, please see http://www.lits.tsinghua.edu.cn/RoboCup
 */

#ifndef _shoot
#define _shoot
#include "bpn.h"
#include "types.h"
#include "Command.h"
#include "Strategy.h"
#include "goingthroughspeed.h"

class ShootInfo{
public:
	float shootangle;
	float min_shootspeed;
	float check_shootspeed;
	float prob_postfail;
	float prob_goaliefail;
	float ShootAngle(){ return shootangle; }
	float MinShootSpeed(){ return min_shootspeed; }
	ShootInfo(){shootangle = 0; min_shootspeed = CP_impossible_speed;}
};

class Shoot : public GT_speed_utils{
private:
	ShootInfo shootinfo[CP_max_shootinfos];
	int num_shootinfo;

	Vector ballpos;
	Vector goaliepos;
	bool goalie_exist;
	Vector Opp_relpos[SP_team_size * 2];
	int num_consider_opp;
	float spreadangle;

	float leftangle;
	float rightangle;
	bool reverse;

	Vector checkpos[CP_max_checkshoot];
	int num_checkpos;

	void AddShootInfo(float min_shootspeed, float shootangle, float goaliefail);
	inline float Getprob_post(float tolerance);
	bool GetShootInfo(float shoot_angle);
public:
	bool GetShootInfo();
	bool SmartShoot();
	KT_Res shoot(ShootInfo& shootinf, Command& command);

	void Initballpos(Vector pos, bool Reverse = false);
	Vector Supposegoalie(Vector pos, float radius);

	inline void Setgoaliepos(Vector relpos);
	void Setgoalieradius(float radius);
	inline void Addopponent(Vector relpos);

	bool GetBestShoot(ShootInfo& info);
	inline float GetShootWidth(){return spreadangle;}

	float GuessShoot(Vector pos, int cycles);
	friend class Handleball;
};

#endif